#ifndef _OSL_CONFIG_H
#define _OSL_CONFIG_H

#include <stdint.h>
#include <boost/static_assert.hpp>

#if ((defined __FreeBSD__) || (defined __CYGWIN32__) || (defined _WIN32))
#  define __WORDSIZE 32
#endif

/**
 * @def OSL_WORDSIZE_64_IN_32
 * 32bit Ķ 64bit ѿȤ
 */
// #define OSL_WORDSIZE_64_IN_32

BOOST_STATIC_ASSERT(__WORDSIZE);
/**
 * @def OSL_WORDSIZE
 * ǡ64bitȤ32bitȤ
 */
#if ((__WORDSIZE == 64) || (defined (OSL_WORDSIZE_64_IN_32)))
#  define OSL_WORDSIZE 64
#else
#  define OSL_WORDSIZE 32
#endif

// #define OSL_NO_SSE 1

#endif /* _OSL_CONFIG_H */
