/* generateCaptureMoves.h
 */
#ifndef _GENERATECAPTUREMOVES_H
#define _GENERATECAPTUREMOVES_H

#include "osl/state/numEffectState.h"
#include "osl/move_action/concept.h"
// CaptureMoves<NumEffectState, StoreMoveAction> ʳȤ߹碌ǻȤȤ
// generateCaptureMoves.tcc include 뤳 (âѥ֤Τǿ侩ʤ)

namespace osl
{
  namespace move_generator
  {
    /**
     * 
     */
    template<Player P>
    class Capture
    {
      // BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
    public:
      /**
       * @param target ΰ (can be empty)
       */
      template<class Action>
      static void generate(const NumEffectState& state,Position target,
			   Action& action);
      /**
       * @param target ΰ (can be empty)
       * @param piece  ζʳǼ
       */
      template<class Action>
      static void escapeByCapture(const NumEffectState& state,Position target,
				  Piece piece,Action& action);
    };

    /**
     * Capture  Player ü첽ǤʤС
     * Player ü첽 Action instantiate ̵̤ʤΤա
     */
    struct GenerateCapture
    {
      template<class Action>
      static void generate(Player p, const NumEffectState& state,Position target,
			   Action& action)
      {
	if (p == BLACK)
	  Capture<BLACK>::generate(state,target,action);
	else
	  Capture<WHITE>::generate(state,target,action);
      }
      template<class Action>
      static void escapeByCapture(Player p, const NumEffectState& state,Position target,
				  Piece piece,Action& action)
      {
	if (p == BLACK)
	  Capture<BLACK>::escapeByCapture(state,target,piece,action);
	else
	  Capture<WHITE>::escapeByCapture(state,target,piece,action);
      }
    };
    
  } // namespace move_generator
} // namespace osl


#endif /* _GENERATECAPTUREMOVES_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
