/* openingBookTracer.h
 */
#ifndef _OPENINGBOOKTRACER_H
#define _OPENINGBOOKTRACER_H

#include "osl/move.h"

namespace osl
{
  namespace game_playing
  {
    /**
     * פ
     */
    class OpeningBookTracer
    {
    protected:
      bool verbose;
    public:
      OpeningBookTracer() : verbose(false) {}
      virtual ~OpeningBookTracer();
      /** new Τ֤ */
      virtual OpeningBookTracer* clone() const = 0;
      /** ؤбƾ֤򹹿롥 */
      virtual void update(Move)=0;
      /**
       * ɤõ֤Ϲʤ
       * @return פϤ줿 Move::INVALID()
       */
      virtual const Move selectMove() const=0;
      virtual bool isOutOfBook() const=0;
      /**
       * ξ֤᤹
       */
      virtual void popMove()=0;
      bool isVerbose() const { return verbose; }
    };

    /**
     * ̵
     */
    class NullBook : public OpeningBookTracer
    {
    public:
      ~NullBook();
      OpeningBookTracer* clone() const 
      {
	return new NullBook();
      }
      
      void update(Move);
      const Move selectMove() const;
      bool isOutOfBook() const;
      void popMove();
    };
    
  } // namespace game_playing
} // namespace osl

#endif /* _OPENINGBOOKTRACER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
