/* dotAnalyzerProof.h
 */
#ifndef _DOTANALYZERPROOF_H
#define _DOTANALYZERPROOF_H

#include "osl/search/analyzer/dotAnalyzer.h"

namespace osl
{
  class MoveLogProb;
  namespace search
  {
    class SimpleHashRecord;
    namespace analyzer
    {
      /**
       * õΥơ֥ʬ.
       * limit μroot ͤΤɬפʼ
       *
       * root Ρ: Ȥ¾ʬ
       * - β lower limit ϤʤΤǡξ
       * - ¾β upper limit ϤʤΤǡξ
       * (֤ʤ lower  upper )
       */
      class DotAnalyzerProof : public DotAnalyzer
      {
      public:
	DotAnalyzerProof(const SimpleHashTable&, std::ostream&);
	~DotAnalyzerProof();

	void analyze(const HashKey& root, int limit);
	void analyzeQuiescence(const HashKey& root);
      private:
	/**
	 * /¤ bound ʾǤڤ.
	 * /¤ϿͤȤƤΤΤǡ֤θΤǤϤʤΤ.
	 */
	void absoluteBound(unsigned int depth, bool is_lower, int bound, 
			   Player turn, int limit,
			   const SimpleHashRecord *from, 
			   const SimpleHashRecord *to, 
			   const MoveLogProb& move);
      };
    } // namespace analyzer
  } // namespace search
} // namespace osl


#endif /* _DOTANALYZERPROOF_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
