/* moveWithComment.h
 */
#ifndef _MOVEWITHCOMMENT_H
#define _MOVEWITHCOMMENT_H

#include "osl/move.h"
#include "osl/stl/vector.h"
#include "osl/hash/hashKey.h"
namespace osl
{
  namespace search
  {
    struct MoveWithComment
    {
      Move move;
      int value;
      vector<Move> moves;
      HashKey root;
      explicit MoveWithComment(Move m=Move::INVALID(), int v=0)
	: move(m), value(v)
      {
      }
      ~MoveWithComment();
    };
  } // namespace search
  using search::MoveWithComment;
} // namespace osl

#endif /* _MOVEWITHCOMMENT_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
