/* searchMove.h
 */
#ifndef _SEARCHMOVE_H
#define _SEARCHMOVE_H

#include "osl/moveLogProb.h"

namespace osl
{
  namespace search
  {
    class SimpleHashRecord;
    struct SearchMove : private MoveLogProb
    {
      mutable SimpleHashRecord *record;
      SearchMove() : record(0)
      {
      }
      explicit SearchMove(const MoveLogProb& move, SimpleHashRecord *r=0) 
	: MoveLogProb(move), record(r)
      {
      }
      using MoveLogProb::getMove;
      using MoveLogProb::getLogProb;
      using MoveLogProb::validMove;
      using MoveLogProb::setLogProbAtMost;
      using MoveLogProb::setLogProbAtLeast;

      const MoveLogProb moveLogProb() const { 
	return static_cast<MoveLogProb>(*this);
      }
    };
  } // namespace search
} // namespace osl

#endif /* _SEARCHMOVE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
